#include "ti86asm.inc"

spritedata  =$9000

.org _asm_exec_ram

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String0                     ;print string

String0: .db "Picture",0

Start:
    call init_ubersprite            ;goes to init_ubersprite
    ld bc,12+(256*3)                ;loads x,y coordinates into bc
    ld ix,TopLeft                   ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,107+(256*3)               ;loads x,y coordinates into bc
    ld ix,TopRight                  ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,12+(256*12)               ;loads x,y coordinates into bc
    ld ix,BottomLeft                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprite
    ld bc,107+(256*12)              ;loads x,y coordinates into bc
    ld ix,BottomRight               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprite
    ld bc,27+(256*0)                ;loads x,y coordinates into bc
    ld ix,LeftClosed                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,92+(256*0)                ;loads x,y coordinates into bc
    ld ix,RightClosed               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,49+(256*16)               ;loads x,y coordinates into bc
    ld ix,LeftClosed                ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld bc,70+(256*16)               ;loads x,y coordinates into bc
    ld ix,RightClosed               ;loads sprite into ix
    call ubersprite                 ;goes to ubersprte
    ld hl,$fc64                     ;loads screen coordinates into hl
    ld b,7                          ;# of times to loop and display @ hl
    call DrawLineHorizontal         ;goes to DrawLineHorizontal
    ld hl,$fd67                     ;loads screen coordinates into hl
    ld b,2                          ;# of times to loop and display @ hl
    call DrawLineHorizontal         ;goes to DrawLineHorizontal
    ld hl,$fc32                     ;loads screen coordinates into hl
    ld b,12                         ;# of times to loop and display @ hl
    call DrawLineHorizontal         ;goes to DrawLineHorizontal
    ld hl,$fd32                     ;loads screen coordinates into hl
    ld b,12                         ;# of times to loop and display @ hl
    call DrawLineHorizontal         ;goes to DrawLineHorizontal
    ld hl,$fc6b                     ;loads screen coordinates into hl
    ld (hl),%11111100               ;loads video mem @ hl w/ line
    ld hl,$fcb1                     ;loads screen coordinates into hl
    ld (hl),%00010000               ;loads video mem @ hl w/ line
    ld hl,$fcbe                     ;loads screen coordinates into hl
    ld (hl),%00010000               ;loads video mem @ hl w/ line
    set 3,(iy+5)                    ;inverts text to white text on black
    ld hl,$0023                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String3                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1038                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    res 3,(iy+5)                    ;reverts text back to black on white
    ld hl,(256*3)+1                 ;loads x,y coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String1                   ;loads hl with string
    call _puts                      ;loads hl into (penCol)
    ret                             ;return to previous program

DrawLineHorizontal:
    ld (hl),%11111111               ;loads video mem @ hl w/ line
    inc hl                          ;moves one to the right
    djnz DrawLineHorizontal         ;repeat until line is drawn
    ret                             ;return to call

String1:    .db "Physics  Solver",0
String2:    .db "v2.4",0
String3:    .db "By Morgan Davies",0

LeftClosed:
    .db %00000111
    .db %00001111
    .db %00011111
    .db %00011111
    .db %00011111
    .db %00001111
    .db %00000111
    .db %00000000

RightClosed:
    .db %11000000
    .db %11100000
    .db %11110000
    .db %11110000
    .db %11110000
    .db %11100000
    .db %11000000
    .db %00000000

TopLeft:
    .db %00001111
    .db %00110000
    .db %01000000
    .db %01000000
    .db %10000000
    .db %10000000
    .db %10000000
    .db %10000000

TopRight:
    .db %11110000
    .db %00001100
    .db %00000010
    .db %00000010
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000001

BottomLeft:
    .db %10000000
    .db %10000000
    .db %10000000
    .db %10000000
    .db %01000000
    .db %01000000
    .db %00110000
    .db %00001111

BottomRight:
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000010
    .db %00000010
    .db %00001100
    .db %11110000

;========================================
;=       UlAligned Sprite Routine       =
;=              UberSprite              =
;=           By: Aaron Curtis           =
;=                                      =
;= Inputs                               =
;=      c  =  x-coordinate              =
;=      b  =  y-coordinate              =
;=      ix -> graphic                   =
;=                                      =
;= Destroys                             =
;=      ix,hl,de,bc,af,d                =
;=                                      =
;========================================

init_ubersprite:
    ld hl,spritedata
    ld d,l
gengfx:
    ld c,0
    ld b,c
gfxloop:
    push bc
    ld b,d
    ld a,d
    or a
    jr z,notshifted
    xor a
shiftloop:
    srl c
    rra
    djnz shiftloop
notshifted:
    ld (hl),c
    inc h
    ld (hl),a
    dec h
    inc hl
    pop bc
    inc c
    djnz gfxloop
    inc h
    inc d
    ld a,d
    cp 8
    jr nz,gengfx
    ret

ubersprite:
;==================
;FindPixil Routine=
;==================
    ld h,$fc/4              ;this will get multiplied by 4 later
                            ;(change the $fc to whatever if you're using a
                            ;  different video plane)
    ld a,b                  ;put y coord in a
    add a,a                 ;--multiply by 4
    add a,a                 ;/
    ld l,a                  ;now put that in l
    ld a,c                  ;put x coord in a
    rra                     ;\
    add hl,hl               ; \
    rra                     ;--- divide a by 8, multiply hl by 4 (must be in this order)
    add hl,hl               ; /
    rra                     ;/
                            ;so now hl is the y coord * 16, added to the appropriate offset
    add a,l
    ld l,a                  ;put the x coord together with hl, to get the offset in video mem
    ld a,c                  ;put the x coord in a
    and %00000111           ;this is the amount the pic must be shifted to the right
                            ;outputs: hl=postion in video mem  a=x-offset
    add a,a
    add a,spritedata/256    ;translate x-offset to address in spritedata
    ld d,a
    ld a,8                  ;doing this for 8 lines
    ld bc,15
uberloop:
    push af
    ld e,(ix+0)
    ld a,(de)                ;draw left half
    or (hl)                 ;** change this to xor (hl), and (hl), or whatever
    ld (hl),a
    inc hl
    inc d
    ld a,(de)                ;draw right half
    or (hl)                 ;** see above
    ld (hl),a
    dec d
    inc ix                  ;move to next line in graphic
    add hl,bc               ;and the next line on the screen
    pop af
    dec a
    jr nz,uberloop
    ret

.end
END