;========================================================================
;                                                                       =
;                          Physics Solver v2.4                          =
;                                                                       =
; Written By:   Morgan Davies                                           =
; E-Mail:       morgan@ticalc.org                                       =
;               Morgazum85@Juno.com                                     =
; Date:         November 22, 2003                                       =
; Size:         2044                                                    =
;                                                                       =
; Info:         This source is very simple and very repeditive. It      =
;   explains the concept of executing assembly programs, displaying     =
;   alligned sprites, drawing horizontal and verticle lines, displaying =
;   text, and some other miscellaneous commands. Very helpful for       =
;   beginners. the source has been well documented.
;                                                                       =
;========================================================================

#include "Asm86.h"
#include "Rom86.h"
#include "Ram86.h"

;.plugin lite86;                     ;the ultimate compression routine

_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp PictureStart1                ;jump to Start1
    .dw 0                           ;type of input
    .dw String3                     ;print string

String3: .db "Physics Solver v2.4",0
#include "BMP2ASM.asm"

PictureStart1:
    call _clrScrn                   ;clears the screen
    call _runindicoff               ;turns run indicator off
    ld de,Picture                   ;load picture into de
    call decompV                    ;goes to decompV
    call _getkey                    ;waits for a key to be pressed
Start1:
    call DrawMenu
    ld hl,$2205                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String5                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2905                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String6                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3005                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String7                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3705                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String8                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$223B                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String9                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$293B                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String10                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$303B                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String11                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$373B                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String12                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1968                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String29                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey1:
    call _getcode                   ;key press stores to a
    cp K_EXIT                       ;compares a with Exit
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a to Alpha
    call z,CalcOff                  ;if Alpha jump to CalcOff
    cp K_RIGHT                      ;compares a to Right
    jr z,Start2                     ;if Right jump to Start2
    cp K_1                          ;compares a with 1
    jp z,Velocity                   ;if 1 jump to label
    cp K_2                          ;compares a with 2
    jp z,Accelera                   ;if 2 jump to label
    cp K_3                          ;compares a with 3
    jp z,Forces                     ;if 3 jump to label
    cp K_4                          ;compares a with 4
    jp z,Vectors                    ;if 4 jump to label
    cp K_5                          ;compares a with 5
    jp z,Motion2D                   ;if 5 jump to label
    cp K_6                          ;compares a with 6
    jp z,Gravity                    ;if 6 jump to label
    cp K_7                          ;compares a with 7
    jp z,Momentum                   ;if 7 jump to label
    cp K_8                          ;compares a with 8
    jp z,Work                       ;if 8 jump to label
    jr GetKey1                      ;jump to getKey1

Start2:
    call DrawMenu
    ld hl,$2204                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String13                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2904                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String14                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3004                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String15                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3704                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String16                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2244                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String17                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2944                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String18                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3044                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String19                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3744                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String20                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1962                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String31                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey2:
    call _getcode                   ;key press stores to a
    cp K_EXIT                       ;compares a with Exit
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a to Alpha
    call z,CalcOff                  ;if Alpha jump to CalcOff
    cp K_LEFT                       ;compares a to Left
    jp z,Start1                     ;if Left jump to Start1
    cp K_RIGHT                      ;compares a to Right
    jr z,Start3                     ;if Right jump to Start3
    cp K_1                          ;compares a with 1
    jp z,Energy                     ;if 1 jump to label
    cp K_2                          ;compares a with 2
    jp z,Thermal                    ;if 2 jump to label
    cp K_3                          ;compares a with 3
    jp z,Matter                     ;if 3 jump to label
    cp K_4                          ;compares a with 4
    jp z,Waves                      ;if 4 jump to label
    cp K_5                          ;compares a with 5
    jp z,Reflecti                   ;if 5 jump to label
    cp K_6                          ;compares a with 6
    jp z,Mirrors                    ;if 6 jump to label
    cp K_7                          ;compares a with 7
    jp z,Diffract                   ;if 7 jump to label
    cp K_8                          ;compares a with 8
    jp z,Electric                   ;if 8 jump to label
    jr GetKey2                      ;jump to getKey2

Start3:
    call DrawMenu
    ld hl,$2208                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String21                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2908                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String22                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3008                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String23                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3708                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String24                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2237                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String25                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$2937                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String26                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3037                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String27                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$3737                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String28                  ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$1968                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String30                  ;loads hl with string
    call _vputs                     ;prints in small text
GetKey3:
    call _getcode                   ;key press stores to a
    cp K_EXIT                       ;compares a with Exit
    jp z,Exit                       ;if Exit jump to Exit
    cp K_ALPHA                      ;compares a to Alpha
    call z,CalcOff                  ;if Alpha jump to CalcOff
    cp K_LEFT                       ;compares a to Left
    jp z,Start2                     ;if Left jump to Start2
    cp K_1                          ;compares a with 1
    jp z,EMFields                   ;if 1 jump to label
    cp K_2                          ;compares a with 2
    jp z,Circuits                   ;if 2 jump to label
    cp K_3                          ;compares a with 3
    jp z,Atom                      ;if 3 jump to label
    cp K_4                          ;compares a with 4
    jp z,Inductio                   ;if 4 jump to label
    cp K_5                          ;compares a with 5
    jp z,Currents                   ;if 5 jump to label
    cp K_6                          ;compares a with 6
    jp z,Quantum                    ;if 6 jump to label
    cp K_7                          ;compares a with 7
    jp z,Magnetic                   ;if 7 jump to label
    cp K_8                          ;compares a with 8
    jp z,Miscelan                   ;if 8 jump to label
    jr GetKey3                      ;jump to getKey2

Velocity:
    ld hl,Prgm2-1                   ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Accelera:
    ld hl,Prgm3-1                   ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Forces:
    ld hl,Prgm4-1                   ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Vectors:
    ld hl,Prgm5-1                   ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Motion2D:
    ld hl,Prgm6-1                   ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Gravity:
    ld hl,Prgm7-1                   ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Momentum:
    ld hl,Prgm8-1                   ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Work:
    ld hl,Prgm9-1                   ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Energy:
    ld hl,Prgm10-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Thermal:
    ld hl,Prgm11-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Matter:
    ld hl,Prgm12-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Waves:
    ld hl,Prgm13-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Reflecti:
    ld hl,Prgm14-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Mirrors:
    ld hl,Prgm15-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Diffract:
    ld hl,Prgm16-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Electric:
    ld hl,Prgm17-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
EMFields:
    ld hl,Prgm18-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Circuits:
    ld hl,Prgm19-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Atom:
    ld hl,Prgm20-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Inductio:
    ld hl,Prgm21-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Currents:
    ld hl,Prgm22-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Quantum:
    ld hl,Prgm23-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Magnetic:
    ld hl,Prgm24-1                  ;loads hl with prgm name to execute
    jr Text1                        ;jump to Text1
Miscelan:
    ld hl,Prgm25-1                  ;loads hl with prgm name to execute

Text1:
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jr c,Text2                      ;if not jump to Text2
    call _exec_assembly             ;execute asm prgm in op1
    jp Start1                       ;jump to Start1

Text2:
    call _clrScrn
    call _homeup                    ;loads hl with (0,0)
    ld hl,String32                  ;loads hl with string
    call _puts                      ;prints in small text
    call _getkey                    ;waits for a key press
    jp Start1                       ;jump to Start1

Text3:
    ld hl,$0000                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String1                   ;loads hl with string
    call _vputs                     ;prints in small text
    ld hl,$0700                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String2                   ;loads hl with string
    call _vputs                     ;prints in small text
    ret                             ;ret to Start1

DrawMenu:
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clears the lcd and graph screen
    call _runindicoff               ;turn off run indicator
    ld hl,Prgm1-1                   ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jr c,Text3                      ;if not jump to Text3
    call _exec_assembly             ;execute asm prgm in op1
    ld hl,TopLeft                   ;loads "TopLeft" sprite
    ld de,$0400                     ;loads coordinates to de
    call GridPutSprite              ;displays sprite
    ld hl,TopRight                  ;loads "TopRight" sprite
    ld de,$040F                     ;loads coordinates to de
    call GridPutSprite              ;displays sprite
    ld hl,BottomLeft                ;loads "BottomLeft" sprite
    ld de,$0700                     ;loads coordinates to de
    call GridPutSprite              ;displays sprite
    ld hl,BottomRight               ;loads "Bottom Right" sprite
    ld de,$070F                     ;loads coordinates to de
    call GridPutSprite              ;displays sprite
    ld hl,$fe80                     ;loads coordinates into hl
    ld b,20                         ;# of times to loop and display c
    ld c,%10000000                  ;what to display @ c
    call DrawLineVertical           ;draws left side line
    ld hl,$fe8f                     ;looads coordinates into hl
    ld b,20                         ;# of times to loop and display c
    ld c,%00000001                  ;what to display @ c
    call DrawLineVertical           ;draws right side line
    ld hl,$fff1                     ;loads coordinates into hl
    ld b,14                         ;# of times to loop and display hl
    call DrawLineHorizontal         ;draws top line
    ld hl,$fe01                     ;loads coordinates into hl
    ld b,14                         ;# of times to loop and display hl
    call DrawLineHorizontal         ;draws bottom line
    ld hl,$1904                     ;loads screen coordinates into hl
    ld (_penCol),hl                 ;loads hl into (penCol)
    ld hl,String4                   ;loads hl with string
    call _vputs                     ;prints in small text
    ret                             ;return to call

CalcOff:
    ld a,1                          ;\
    out (3),a                       ;  \
    halt                            ;    \
    ld a,11                         ;      > turns off calculator???
    out (3),a                       ;    /
    res onInterrupt,(iy+onflags)    ;  /
    ret                             ;/

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

Prgm1:      .db 4,"",45,"phy"
Prgm2:      .db 8,"Velocity"
Prgm3:      .db 8,"Accelera"
Prgm4:      .db 6,"Forces"
Prgm5:      .db 7,"Vectors"
Prgm6:      .db 8,"Motion2D"
Prgm7:      .db 7,"Gravity"
Prgm8:      .db 8,"Momentum"
Prgm9:      .db 4,"Work"
Prgm10:     .db 6,"Energy"
Prgm11:     .db 7,"Thermal"
Prgm12:     .db 6,"Matter"
Prgm13:     .db 5,"Waves"
Prgm14:     .db 8,"Reflecti"
Prgm15:     .db 7,"Mirrors"
Prgm16:     .db 8,"Diffract"
Prgm17:     .db 8,"Electric"
Prgm18:     .db 8,"EMFields"
Prgm19:     .db 8,"Circuits"
Prgm20:     .db 4,"Atom"
Prgm21:     .db 8,"Inductio"
Prgm22:     .db 8,"Currents"
Prgm23:     .db 7,"Quantum"
Prgm24:     .db 8,"Magnetic"
Prgm25:     .db 8,"Miscelan"
String1:    .db "Written By Morgan Davies",0
String2:    .db "Missing File      ",34,"-phy.86p",34,"",0
String4:    .db "Choose a Subject:",0
String5:    .db "1. Velocity",0
String6:    .db "2. Acceleration",0
String7:    .db "3. Forces",0
String8:    .db "4. Vectors",0
String9:    .db "5. Motion 2D",0
String10:   .db "6. Universal Gravity",0
String11:   .db "7. Momentum",0
String12:   .db "8. Power and Work",0
String13:   .db "1. Energy",0
String14:   .db "2. Thermal Energy",0
String15:   .db "3. States of Matter",0
String16:   .db "4. Waves",0
String17:   .db "5. Reflection",0
String18:   .db "6. Mirrors",0
String19:   .db "7. Diffraction",0
String20:   .db "8. Electric Fields",0
String21:   .db "1. EM Fields",0
String22:   .db "2. Circuits",0
String23:   .db "3. The Atom",0
String24:   .db "4. Induction",0
String25:   .db "5. Electric Currents",0
String26:   .db "6. Quantum Theory",0
String27:   .db "7. Magnetic Fields",0
String28:   .db "8. Miscellaneous",0
String29:   .db "More ",5,0
String30:   .db "More ",207,0
String31:   .db "More ",207,5,0
String32:   .db "This program is not  on your calc!",0

DrawLineVertical:
    ld de,$10                       ;loads de with $10
LineLoop:
    ld a,(hl)                       ;loads a with contents of video mem @ hl
    or c                            ;turns on the pixels specified by c w/o affecting others
    ld (hl),a                       ;loads a back into video mem
    add hl,de                       ;moves to next line
    djnz LineLoop                   ;repeat until b=0
    ret                             ;return

DrawLineHorizontal:
    ld (hl),%11111111               ;loads video mem @ hl w/ line
    inc hl                          ;moves one to the right
    djnz DrawLineHorizontal         ;repeat until line is drawn
    ret                             ;return to call

GridPutSprite:
    push hl                         ; push hl to stack
    pop ix                          ; ...and pop it into iy
    srl d                           ; de = (128 * y) + x
    rra                             ; carry flag -< msb of a
    and $80                         ; a is either $00 or %80
    or e                            ; add x offset (remember x <= 15
    ld e,a                          ; de = (128 * y) + (x * 8)
    ld hl,$fc00                     ; hl-> video memory
    add hl,de                       ; hl-> video memory + offset
    ld b,8                          ; initialize loop counter
    ld de,16                        ; screen is 16 bytes wide

GPS_Loop:
    ld a,(ix + 0)                   ; get byte from sprite
    ld c,(hl)                       ; load c w/contents of video mem                    |These two lines are
    or c                            ; turn on pixels in sprite w/o turning off others   |my own additions
    ld (hl),a                       ; put byte on screen
    inc ix                          ; move to next byte in sprite
    add hl,de                       ; move to next line on screen
    djnz GPS_Loop                   ; loop until sprite is drawn
    ret                             ; return

TopLeft:
    .db %00001111
    .db %00110000
    .db %01000000
    .db %01000000
    .db %10000000
    .db %10000000
    .db %10000000
    .db %10000000

TopRight:
    .db %11110000
    .db %00001100
    .db %00000010
    .db %00000010
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000001

BottomLeft:
    .db %10000000
    .db %10000000
    .db %10000000
    .db %10000000
    .db %01000000
    .db %01000000
    .db %00110000
    .db %00001111

BottomRight:
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000001
    .db %00000010
    .db %00000010
    .db %00001100
    .db %11110000

Picture:
;Compressed picture made with BMP2ASM by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 343 bytes - 67% compressed!
  .db $B7, $00, $49, $01, $01, $B7, $00, $24, $1F, $11, $11, $11, $1F, $B7, $1C, $04
  .db $1F, $B7, $00, $0E, $FF, $20, $00, $C0, $80, $80, $83, $FC, $B7, $80, $04, $C0
  .db $B7, $00, $1F, $B7, $A2, $05, $BE, $B7, $06, $04, $B7, $00, $0A, $04, $98, $58
  .db $48, $48, $88, $88, $0C, $0A, $09, $08, $08, $08, $B7, $00, $3B, $18, $88, $CC
  .db $C5, $83, $02, $06, $01, $B7, $00, $18, $FF, $B7, $82, $04, $B7, $E2, $05, $B7
  .db $00, $16, $CF, $90, $8E, $11, $1F, $B7, $00, $0C, $63, $22, $22, $14, $08, $B7
  .db $00, $0A, $F0, $10, $10, $10, $17, $B7, $14, $04, $17, $B7, $00, $12, $10, $00
  .db $00, $00, $93, $14, $14, $92, $B1, $B7, $00, $04, $7F, $40, $B7, $00, $04, $01
  .db $02, $04, $08, $1C, $33, $40, $B7, $00, $0E, $EF, $29, $2C, $2C, $2C, $EC, $B7
  .db $00, $16, $C7, $28, $07, $28, $CF, $B7, $00, $04, $C0, $B7, $40, $04, $80, $B7
  .db $00, $04, $06, $CE, $8E, $B7, $00, $0E, $7D, $48, $49, $79, $21, $21, $7C, $64
  .db $64, $7C, $B7, $00, $0D, $01, $B7, $00, $04, $C0, $00, $01, $C1, $C1, $B7, $00
  .db $04, $0E, $0E, $0C, $08, $14, $24, $24, $44, $BD, $46, $04, $06, $04, $B7, $00
  .db $0E, $E7, $24, $E6, $A6, $A6, $F6, $B7, $00, $0E, $1F, $61, $80, $00, $80, $60
  .db $1E, $01, $00, $00, $00, $C0, $FF, $B7, $00, $0C, $80, $B7, $00, $12, $C0, $B7
  .db $40, $05, $B7, $00, $0E, $80, $80, $80, $B7, $00, $04, $80, $4F, $30, $30, $51
  .db $8F, $B7, $00, $1B, $1F, $B7, $10, $04, $18, $1C, $1C, $1C, $1F, $B7, $00, $0E
  .db $30, $B7, $10, $07, $16, $92, $92, $91, $38, $20, $B7, $00, $1A, $E0, $20, $20
  .db $20, $2F, $21, $2F, $2D, $2D, $EF, $B7, $00, $16, $33, $25, $27, $44, $83, $B7
  .db $00, $1F, $32, $32, $32, $34, $14, $9C, $B7, $00, $16, $CF, $08, $08, $68, $D8
  .db $B7, $00, $1D, $80, $00, $9F, $99, $DF, $D8, $D9, $DF, $B7, $00, $3A, $7C, $40
  .db $7C, $0C, $4C, $7C, $B7, $00, $48

.end
END